export declare class ENVConfig {
    CLUSTER_WALLET_ADDRESS: string;
    CLUSTER_OPERATOR_ADDRESS: string;
    CLUSTER_PRIVATE_KEY: string;
    CLUSTER_UMBRAL_SECRET_KEY: number[];
    SUBNET_ID: string;
    CLUSTER_ID: string;
    BACKEND_URL: string;
    URSULA_URL_LIST: string[];
    JSON_RPC_URL: string;
    SOCKET_RPC_URL: string;
    IPFS_PROJECT_ID: string;
    IPFS_PROJECT_SECRET: string;
    LIGHTHOUSE_API_KEY: string;
    MONGODB_URL: string;
    NFT_TRACKER_URL: string;
    MONGODB_DBNAME: string;
    CLOUDFLARE_DOMAIN: string;
    CONTRACT_ADDRESSES: {
        Registration: string;
        SubscriptionBalance: string;
        AppDeployment: string;
        OrderPayment: string;
    };
    SYSTEM_ENV: {
        FIRST_RUN_BOOT_FLAG: boolean;
        BLOCK_TIME: number;
        MAX_BLOCK_DIFF: number;
        IPFS_CALL_LIMIT: number;
        URSULA_CALL_LIMIT: number;
        NFTTRACKER_ST_DURATION: number;
        NFTTRACKER_LT_DURATION: number;
        NFTTRACKER_DAILY_DURATION: number;
        NFTLOG_DB_UPLOAD_DURATION: number;
        SYSLOG_DB_UPLOAD_DURATION: number;
        APPSTATUS_UPLOAD_DURATION: number;
        PROCESSED_BLOCK_UPLOAD_DURATION: number;
        HEARTBEAT_DURATION: number;
        UPDATE_DURATION: number;
        BE_GETDEPLIST_LIMIT: number;
        BE_POSTAPP_LIMIT: number;
        BE_DELAPP_LIMIT: number;
        BE_POSTWEBTTY_LIMIT: number;
        CONT_GETAPPLIST_LIMIT: number;
        CONT_GETBALTIME_LIMIT: number;
        LISTSERV_PING_RESP_DURATION: number;
        LISTSERV_LIFECHECK_INTERVAL: number;
        LISTSERV_BLOCKADD_TIME: number;
        NFTEXEC_WAIT: number;
    };
    setSystemENV: (name: string, value: any) => void;
    setupENV: () => void;
}
export declare const envConfig: ENVConfig;
