"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.envConfig = exports.ENVConfig = void 0;
var dotenv_1 = require("dotenv");
var DEFAULT_SYSTEM_ENV = {
    FIRST_RUN_BOOT_FLAG: false,
    BLOCK_TIME: 2,
    MAX_BLOCK_DIFF: 100000,
    IPFS_CALL_LIMIT: 5,
    URSULA_CALL_LIMIT: 5,
    NFTTRACKER_ST_DURATION: 60 * 1000,
    NFTTRACKER_LT_DURATION: 10 * 1000,
    NFTTRACKER_DAILY_DURATION: 1000 * 60 * 60 * 24,
    NFTLOG_DB_UPLOAD_DURATION: 5000,
    SYSLOG_DB_UPLOAD_DURATION: 5000,
    APPSTATUS_UPLOAD_DURATION: 2000,
    PROCESSED_BLOCK_UPLOAD_DURATION: 1000,
    HEARTBEAT_DURATION: 15 * 1000,
    UPDATE_DURATION: 1000 / 10,
    BE_GETDEPLIST_LIMIT: 100,
    BE_POSTAPP_LIMIT: 100,
    BE_DELAPP_LIMIT: 100,
    BE_POSTWEBTTY_LIMIT: 100,
    CONT_GETAPPLIST_LIMIT: 10,
    CONT_GETBALTIME_LIMIT: 10,
    LISTSERV_PING_RESP_DURATION: 15000,
    LISTSERV_LIFECHECK_INTERVAL: 7500,
    LISTSERV_BLOCKADD_TIME: 20000,
    NFTEXEC_WAIT: 7000,
};
var ENVConfig = /** @class */ (function () {
    function ENVConfig() {
        var _this = this;
        this.setSystemENV = function (name, value) {
            _this.SYSTEM_ENV[name] = value;
        };
        this.setupENV = function () {
            (0, dotenv_1.config)();
            _this.CONTRACT_ADDRESSES = {
                AppDeployment: process.env.APP_DEPLOYMENT_CONTRACT_ADDRESS,
                SubscriptionBalance: process.env.SUBSCRIPTION_BALANCE_CONTRACT_ADDRESS,
                Registration: process.env.REGISTRATION_CONTRACT_ADDRESS,
                OrderPayment: process.env.ORDER_PAYMENT_CONTRACT_ADDRESS,
            };
            Array.from(Buffer.from(process.env.CLUSTER_OPERATOR_SECRET_KEY, "hex"));
            _this.BACKEND_URL = process.env.BACKEND_PROXY_URL;
            _this.CLUSTER_OPERATOR_ADDRESS = process.env.CLUSTER_OPERATOR_OP_ADDRESS;
            _this.CLUSTER_WALLET_ADDRESS =
                process.env.CLUSTER_OPERATOR_WALLET_ADDRESS;
            _this.CLUSTER_PRIVATE_KEY = process.env.CLUSTER_OPERATOR_PRIVATE_KEY;
            // this.CLUSTER_UMBRAL_SECRET_KEY = libUtils.convertIntoUmbralSecretKey(
            //     Array.from(
            //         Buffer.from(process.env.CLUSTER_OPERATOR_SECRET_KEY, "hex"),
            //     ),
            // );
            _this.CLUSTER_UMBRAL_SECRET_KEY = Array.from(Buffer.from(process.env.CLUSTER_OPERATOR_SECRET_KEY, "hex"));
            _this.SUBNET_ID = process.env.SUBNET_ID;
            _this.CLUSTER_ID = process.env.CLUSTER_ID;
            _this.URSULA_URL_LIST = [
                process.env.URSULA_URL1,
                process.env.URSULA_URL2,
                process.env.URSULA_URL3,
                process.env.URSULA_URL4,
                process.env.URSULA_URL5,
                process.env.URSULA_URL6,
                process.env.URSULA_URL7,
                process.env.URSULA_URL8,
                process.env.URSULA_URL9,
            ];
            _this.JSON_RPC_URL = process.env.JSON_RPC_URL;
            _this.SOCKET_RPC_URL = process.env.SOCKET_RPC_URL;
            _this.IPFS_PROJECT_ID = process.env.IPFS_PROJECT_ID;
            _this.IPFS_PROJECT_SECRET = process.env.IPFS_PROJECT_SECRET;
            _this.LIGHTHOUSE_API_KEY = process.env.LIGHTHOUSE_API_KEY;
            _this.MONGODB_URL = process.env.MONGODB_URL;
            _this.MONGODB_DBNAME = process.env.MONGODB_DBNAME;
            _this.CLOUDFLARE_DOMAIN = process.env.CLOUDFLARE_DOMAIN;
            _this.NFT_TRACKER_URL = process.env.NFT_TRACKER_URL;
            _this.SYSTEM_ENV = __assign({}, DEFAULT_SYSTEM_ENV);
        };
    }
    return ENVConfig;
}());
exports.ENVConfig = ENVConfig;
exports.envConfig = new ENVConfig();
