"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NFTEventProcessor = exports.NFTExecuteClass = void 0;
var utils_1 = require("../utils/utils");
var mutex_1 = __importDefault(require("../utils/mutex"));
var NFTExecuteClass = /** @class */ (function () {
    function NFTExecuteClass(nftEvent, callFunc) {
        var _this = this;
        this.executeEvents = function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/];
        }); }); };
        // this.nftEventCollection = nftEventCollection;
        this.nftEvent = nftEvent;
        this.executionStatus = "idle";
        this.blockProcessed = [];
        this.callFunc = callFunc;
    }
    NFTExecuteClass.prototype.execute = function () {
        return __awaiter(this, void 0, void 0, function () {
            var blocksProcessed, callFuncResp, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.executionStatus = "running";
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        blocksProcessed = [];
                        return [4 /*yield*/, this.callFunc(this.nftEvent)];
                    case 2:
                        callFuncResp = _a.sent();
                        if (callFuncResp.success == false)
                            throw callFuncResp.data;
                        this.blockProcessed = callFuncResp.data;
                        this.executionStatus = "success";
                        console.log("successfully processed: ", this.blockProcessed, this.nftEvent);
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        this.executionStatus = "fail";
                        console.log("execution failed", err_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    return NFTExecuteClass;
}());
exports.NFTExecuteClass = NFTExecuteClass;
var NFTEventProcessor = /** @class */ (function () {
    function NFTEventProcessor(contractService, callFunc) {
        var _this = this;
        this.blockNumberToIDMap = {};
        this.runningEventList = [];
        this.collectedBlockList = [];
        this.blockEventCountMap = {};
        this.nftEventMap = {};
        this.isNFTRunning = {};
        this.completedBlockList = [];
        this.blockToWriteList = [];
        this.shouldRunTick = false;
        this.nextRunTime = new Date().getTime();
        this.RUN_INTERVAL = 2000;
        this.collectedBlockMutex = new mutex_1.default();
        // filterToABIMap = {};
        // filterToNFTMap = {};
        // filterToAppIDMap = {};
        this.filterToParamMap = {};
        this.filterToEventIDMap = {};
        this.filters = undefined;
        this.setup = function () { return __awaiter(_this, void 0, void 0, function () {
            var OrderPayment, paymentReceivedFilter;
            var _a;
            return __generator(this, function (_b) {
                OrderPayment = this.contractService.getOrderPayment();
                paymentReceivedFilter = OrderPayment.filters
                    .PaymentReceived()
                    .topics[0].toString();
                console.log("paymentReceivedFilter: ", paymentReceivedFilter);
                this.filters = {
                    paymentReceived: paymentReceivedFilter,
                };
                this.filterToParamMap = (_a = {},
                    _a[paymentReceivedFilter] = utils_1.convertPaymentReceivedParam,
                    _a);
                return [2 /*return*/];
            });
        }); };
        this.addCollectedBlockInternal = function (blockNumber, waitingStatus) {
            var entryID = -1;
            var lastReceivedTime = new Date();
            var blockNumStr = blockNumber.toString();
            if (_this.blockNumberToIDMap[blockNumStr] != undefined) {
                var blockEntryID = _this.blockNumberToIDMap[blockNumStr];
                var blockEvents = _this.collectedBlockList[blockEntryID];
                blockEvents.lastReceivedTime = lastReceivedTime.getTime();
                blockEvents.waitingStatus = waitingStatus;
                entryID = blockEntryID;
            }
            else {
                var blockEvents = {
                    blockNumber: blockNumber,
                    eventList: [],
                    lastReceivedTime: lastReceivedTime.getTime(),
                    waitingStatus: waitingStatus,
                };
                _this.blockNumberToIDMap[blockNumStr] =
                    _this.collectedBlockList.length;
                _this.collectedBlockList.push(blockEvents);
                entryID = _this.blockNumberToIDMap[blockNumStr];
            }
            return entryID;
        };
        this.collectEvents = function (waitingStatus, nftEventList) { return __awaiter(_this, void 0, void 0, function () {
            var i, nftEvent, blockNumber, entryID;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.collectedBlockMutex.lock()];
                    case 1:
                        _a.sent();
                        console.log("nftEventList: ", nftEventList);
                        for (i = 0; i < nftEventList.length; i++) {
                            nftEvent = nftEventList[i];
                            blockNumber = nftEvent.blockNumber;
                            entryID = this.addCollectedBlockInternal(blockNumber, waitingStatus);
                            this.collectedBlockList[entryID].eventList.push(nftEvent);
                        }
                        return [4 /*yield*/, this.collectedBlockMutex.release()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.collectBlock = function (blockNumber, waitingStatus) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.collectedBlockMutex.lock()];
                    case 1:
                        _a.sent();
                        this.addCollectedBlockInternal(blockNumber, waitingStatus);
                        return [4 /*yield*/, this.collectedBlockMutex.release()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.saveCompletedBlocks = function () {
            var runningBlockNumList = Object.keys(_this.blockEventCountMap).map(function (x) { return Number(x); });
            var smallestBlockNum = Number.MAX_VALUE;
            if (runningBlockNumList.length == 0)
                return;
            for (var i = 0; i < runningBlockNumList.length; i++) {
                var blockNumber = runningBlockNumList[i];
                if (_this.blockEventCountMap[blockNumber] <= 0) {
                    _this.completedBlockList.push(blockNumber);
                    delete _this.blockEventCountMap[blockNumber];
                }
                else {
                    if (smallestBlockNum > blockNumber) {
                        smallestBlockNum = blockNumber;
                    }
                }
            }
            if (_this.completedBlockList.length == 0)
                return;
            // console.log(
            //     "save completed blocks: ",
            //     this.completedBlockList,
            //     runningBlockNumList,
            //     smallestBlockNum,
            // );
            var newCompBlockList = [];
            for (var i = 0; i < _this.completedBlockList.length; i++) {
                var blockNumber = _this.completedBlockList[i];
                if (blockNumber > smallestBlockNum) {
                    newCompBlockList.push(blockNumber);
                    continue;
                }
                _this.blockToWriteList.push(blockNumber);
            }
            _this.completedBlockList = newCompBlockList;
        };
        this.addNFTEvents = function (nftEvent) {
            var eventType = nftEvent.eventType;
            // const nftID = nftEvent.nftID.toString();
            // if (!this.nftEventMap[nftID]) {
            //     this.nftEventMap[nftID] = {
            //         nftID: nftID,
            //         update: [],
            //         delete: [],
            //     };
            // }
            // if (eventType === "delete") {
            //     const appID = nftEvent.appID;
            //     this.nftEventMap[nftID].update = removePreviousAppEvents(
            //         this.nftEventMap[nftID].update,
            //         appID,
            //     );
            //     this.nftEventMap[nftID].delete.push(nftEvent);
            // }
        };
        this.handleCompletedEvents = function () {
            var newRunningEventList = [];
            if (_this.runningEventList.length == 0)
                return;
            for (var i = 0; i < _this.runningEventList.length; i++) {
                var nftEvent = _this.runningEventList[i];
                if (!(nftEvent.executionStatus == "success" ||
                    nftEvent.executionStatus == "fail")) {
                    newRunningEventList.push(nftEvent);
                }
                else {
                    console.log("nftEvent.blockProcessed: ", nftEvent.blockProcessed);
                    for (var j = 0; j < nftEvent.blockProcessed.length; j++) {
                        var blockNumber = nftEvent.blockProcessed[j];
                        // const blockNumStr = blockNumber.toString();
                        console.log("block event count map: ", _this.blockEventCountMap);
                        var blockCount = _this.blockEventCountMap[blockNumber];
                        _this.blockEventCountMap[blockNumber] =
                            (blockCount || 0) - 1;
                    }
                }
            }
            _this.runningEventList.length = 0;
            for (var i = 0; i < newRunningEventList.length; i++) {
                _this.runningEventList.push(newRunningEventList[i]);
            }
        };
        // saveCompletedBlocks = () => {
        // }
        this.getReadyBlocksFromCollectedList = function () { return __awaiter(_this, void 0, void 0, function () {
            var WAIT_DURATION, firstWaitingBlock, readyBlockList, curTime, i, blockEvents, key, i, blockEvents, zeroBlockList, plusBlockList, i, readyBlock, blockNumber;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        WAIT_DURATION = 1000;
                        if (this.collectedBlockList.length == 0)
                            return [2 /*return*/, []];
                        return [4 /*yield*/, this.collectedBlockMutex.lock()];
                    case 1:
                        _a.sent();
                        this.collectedBlockList.sort(function (a, b) {
                            return a.blockNumber > b.blockNumber ? 0 : -1;
                        });
                        firstWaitingBlock = -1;
                        readyBlockList = [];
                        curTime = new Date().getTime();
                        for (i = 0; i < this.collectedBlockList.length; i++) {
                            blockEvents = this.collectedBlockList[i];
                            if (blockEvents.waitingStatus ||
                                blockEvents.lastReceivedTime + WAIT_DURATION > curTime) {
                                break;
                            }
                            firstWaitingBlock = i;
                        }
                        if (firstWaitingBlock > -1) {
                            readyBlockList = this.collectedBlockList.splice(0, firstWaitingBlock + 1);
                        }
                        for (key in this.blockNumberToIDMap) {
                            delete this.blockNumberToIDMap[key];
                        }
                        for (i = 0; i < this.collectedBlockList.length; i++) {
                            blockEvents = this.collectedBlockList[i];
                            this.blockNumberToIDMap[blockEvents.blockNumber.toString()] = i;
                        }
                        return [4 /*yield*/, this.collectedBlockMutex.release()];
                    case 2:
                        _a.sent();
                        zeroBlockList = [];
                        plusBlockList = [];
                        for (i = 0; i < readyBlockList.length; i++) {
                            readyBlock = readyBlockList[i];
                            blockNumber = readyBlock.blockNumber;
                            if (readyBlock.eventList.length > 0) {
                                plusBlockList.push(readyBlock);
                                this.blockEventCountMap[blockNumber] =
                                    readyBlock.eventList.length;
                            }
                            else {
                                zeroBlockList.push(readyBlock);
                                this.blockEventCountMap[blockNumber] = 0;
                            }
                        }
                        return [2 /*return*/, plusBlockList];
                }
            });
        }); };
        this.addNFTEventsFromReadyBlocks = function (readyBlockList) {
            if (readyBlockList.length == 0)
                return;
            for (var i = 0; i < readyBlockList.length; i++) {
                var blockEvents = readyBlockList[i];
                for (var j = 0; j < blockEvents.eventList.length; j++) {
                    var nftEvent = blockEvents.eventList[j];
                    var nftEventExecutable = new NFTExecuteClass(nftEvent, _this.callFunc);
                    nftEventExecutable.execute();
                    _this.runningEventList.push(nftEventExecutable);
                }
            }
            console.log("nft events added: ", _this.nftEventMap);
        };
        // addRunningEvents = () => {
        //     const nftList = Object.keys(this.nftEventMap);
        //     for (let i = 0; i < nftList.length; i++) {
        //         const nftID = nftList[i];
        //         if (this.isNFTRunning[nftID]) continue;
        //         const nftEventExecutable = new NFTEventClass(
        //             this.nftEventMap[nftID],
        //         );
        //         nftEventExecutable.execute();
        //         this.isNFTRunning[nftID] = true;
        //         console.log("executing event:", nftEventExecutable);
        //         this.runningEventList.push(nftEventExecutable);
        //         delete this.nftEventMap[nftID];
        //     }
        // };
        this.getBlockToWriteList = function () {
            return _this.blockToWriteList;
        };
        this.clearBlockToWriteList = function () {
            _this.blockToWriteList = [];
        };
        this.getAndClearBlockToWriteList = function () {
            var blockToWriteList = _this.blockToWriteList;
            _this.blockToWriteList = [];
            return blockToWriteList;
        };
        this.setRunTick = function (flag) {
            _this.shouldRunTick = flag;
        };
        this.update = function () { return __awaiter(_this, void 0, void 0, function () {
            var readyBlockList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.shouldRunTick)
                            return [2 /*return*/];
                        if (new Date().getTime() < this.nextRunTime)
                            return [2 /*return*/];
                        this.nextRunTime = new Date().getTime() + this.RUN_INTERVAL;
                        this.handleCompletedEvents();
                        return [4 /*yield*/, this.getReadyBlocksFromCollectedList()];
                    case 1:
                        readyBlockList = _a.sent();
                        this.addNFTEventsFromReadyBlocks(readyBlockList);
                        // this.addRunningEvents();
                        this.saveCompletedBlocks();
                        return [2 /*return*/];
                }
            });
        }); };
        this.contractService = contractService;
        this.callFunc = callFunc;
    }
    return NFTEventProcessor;
}());
exports.NFTEventProcessor = NFTEventProcessor;
