import { Web3Service } from "../config/ethersConfig";
import { NFTEventProcessor } from "../events/eventProcessor";
import { DatabaseWriterExecution } from "../utils/databaseWriterExecution";
import { COService } from "../utils/service";
import { ContractService } from "./contractService";
import { DatabaseService } from "./databaseService";
import { SystemLogService } from "./systemLogService";
export declare class BootEventCollectService implements COService {
    bootupStatus: "idle" | "start" | "running" | "succeeded" | "failed";
    lastBlockNumber: number;
    currentBlockNumber: number;
    blocksToWriteList: number[];
    databaseWriter: DatabaseWriterExecution<number[]>;
    bootupBlockParam: {
        oldestBlock: number;
        currentBlock: number;
    };
    databaseService: DatabaseService;
    web3Service: Web3Service;
    contractService: ContractService;
    systemLogService: SystemLogService;
    eventProcessor: NFTEventProcessor;
    firstRunBootFlag: boolean;
    constructor(databaseService: DatabaseService, contractService: ContractService, eventProcessor: NFTEventProcessor, web3Service: Web3Service, systemLogService: SystemLogService);
    setup: () => Promise<void>;
    setBootupStatus: (status: any) => void;
    setBlocksToReady: () => Promise<void>;
    fetchBalanceEventsFromBlock: (fromBlock: number, toBlock: number) => Promise<void>;
    fetchEventsSinceLastRun: () => Promise<void>;
    getBlocksToProcess: () => Promise<void>;
    startBootup: () => void;
    bootup: () => Promise<void>;
    addBlocksToWriteInternal: (blockList: number[]) => void;
    addBlocksToWrite: (blockList: number[]) => Promise<void>;
    saveBlocksToDatabase: () => Promise<void>;
    update: () => Promise<void>;
}
