"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BootEventCollectService = void 0;
var envConfig_1 = require("../config/envConfig");
var databaseWriterExecution_1 = require("../utils/databaseWriterExecution");
var utils_1 = require("../utils/utils");
var BootEventCollectService = /** @class */ (function () {
    function BootEventCollectService(databaseService, contractService, eventProcessor, web3Service, systemLogService) {
        var _this = this;
        this.setup = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, PROCESSED_BLOCK_UPLOAD_DURATION, FIRST_RUN_BOOT_FLAG;
            return __generator(this, function (_b) {
                _a = envConfig_1.envConfig.SYSTEM_ENV, PROCESSED_BLOCK_UPLOAD_DURATION = _a.PROCESSED_BLOCK_UPLOAD_DURATION, FIRST_RUN_BOOT_FLAG = _a.FIRST_RUN_BOOT_FLAG;
                this.firstRunBootFlag = FIRST_RUN_BOOT_FLAG;
                this.databaseWriter = new databaseWriterExecution_1.DatabaseWriterExecution("processedBlockWriter", this.saveBlocksToDatabase, this.addBlocksToWrite, PROCESSED_BLOCK_UPLOAD_DURATION);
                this.blocksToWriteList = [];
                this.bootupStatus = "idle";
                return [2 /*return*/];
            });
        }); };
        this.setBootupStatus = function (status) {
            _this.bootupStatus = status;
        };
        this.setBlocksToReady = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, oldestBlock, currentBlock, i;
            return __generator(this, function (_b) {
                _a = this.bootupBlockParam, oldestBlock = _a.oldestBlock, currentBlock = _a.currentBlock;
                for (i = oldestBlock; i <= currentBlock; i++) {
                    this.eventProcessor.collectBlock(i, false);
                }
                return [2 /*return*/];
            });
        }); };
        this.fetchBalanceEventsFromBlock = function (fromBlock, toBlock) { return __awaiter(_this, void 0, void 0, function () {
            var OrderPayment, logDataList, eventList;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        OrderPayment = this.contractService.getOrderPayment();
                        return [4 /*yield*/, this.web3Service.getHTTPProvider().getLogs({
                                fromBlock: fromBlock,
                                toBlock: toBlock,
                                address: envConfig_1.envConfig.CONTRACT_ADDRESSES.OrderPayment,
                            })];
                    case 1:
                        logDataList = _a.sent();
                        eventList = logDataList
                            .map(function (log) {
                            var blockNumber = log.blockNumber;
                            var topicList = log.topics.map(function (x) { return x; });
                            var events = OrderPayment.interface.parseLog({
                                topics: topicList,
                                data: log.data,
                            });
                            var filter = events.topic;
                            var params = events.args;
                            if (!_this.eventProcessor.filterToParamMap[filter])
                                return null;
                            var nftEvent = _this.eventProcessor.filterToParamMap[filter](blockNumber, params);
                            return nftEvent;
                        })
                            .filter(function (event) { return event != null; });
                        if (eventList.length > 0) {
                            eventList.forEach(function (event) {
                                _this.eventProcessor.collectEvents(false, [event]);
                            });
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        this.fetchEventsSinceLastRun = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, oldestBlock, currentBlock, fetchEvents;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.bootupBlockParam, oldestBlock = _a.oldestBlock, currentBlock = _a.currentBlock;
                        if (oldestBlock > currentBlock) {
                            console.log("nothing to scan, the block number is the latest. old: ", oldestBlock, "new: ", currentBlock);
                            return [2 /*return*/];
                        }
                        fetchEvents = function (oldestBlock, currentBlock, fetchEventFunc) { return __awaiter(_this, void 0, void 0, function () {
                            var blockInc, maxBlockStride, blockStride, successCount, curBlockStride, err_1;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        blockInc = oldestBlock;
                                        maxBlockStride = 20;
                                        blockStride = maxBlockStride;
                                        successCount = 0;
                                        _a.label = 1;
                                    case 1:
                                        if (!(blockInc <= currentBlock)) return [3 /*break*/, 6];
                                        curBlockStride = Math.min(blockStride, currentBlock - blockInc);
                                        _a.label = 2;
                                    case 2:
                                        _a.trys.push([2, 4, , 5]);
                                        console.log("fetching events: ", blockInc, blockInc + curBlockStride);
                                        return [4 /*yield*/, fetchEventFunc(blockInc, blockInc + curBlockStride)];
                                    case 3:
                                        _a.sent();
                                        successCount += 1;
                                        if (successCount > 5) {
                                            blockStride = Math.min(blockStride + 1, maxBlockStride);
                                            successCount += 1;
                                        }
                                        blockInc += curBlockStride + 1;
                                        return [3 /*break*/, 5];
                                    case 4:
                                        err_1 = _a.sent();
                                        console.error("failed to fetch block: ", err_1);
                                        blockStride = Math.max(blockStride - 1, 0);
                                        return [3 /*break*/, 5];
                                    case 5: return [3 /*break*/, 1];
                                    case 6: return [2 /*return*/];
                                }
                            });
                        }); };
                        return [4 /*yield*/, fetchEvents(oldestBlock, currentBlock, this.fetchBalanceEventsFromBlock)];
                    case 1:
                        _b.sent();
                        console.log("done with fetching events");
                        return [2 /*return*/];
                }
            });
        }); };
        this.getBlocksToProcess = function () { return __awaiter(_this, void 0, void 0, function () {
            var MAX_BLOCK_DIFF, resp, currentBlockNum, oldestBlockNum, blockInc;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        MAX_BLOCK_DIFF = envConfig_1.envConfig.SYSTEM_ENV.MAX_BLOCK_DIFF;
                        return [4 /*yield*/, this.databaseService.getMaxProcessedBlock()];
                    case 1:
                        resp = _a.sent();
                        if (!resp.success)
                            throw resp.data;
                        return [4 /*yield*/, this.web3Service
                                .getHTTPProvider()
                                .getBlockNumber()];
                    case 2:
                        currentBlockNum = _a.sent();
                        oldestBlockNum = 0;
                        if (resp.data == null) {
                            if (this.firstRunBootFlag) {
                                oldestBlockNum = 0;
                            }
                            else {
                                oldestBlockNum = currentBlockNum;
                            }
                        }
                        else {
                            oldestBlockNum = resp.data.blockNumber;
                        }
                        console.log("block num from database: ", oldestBlockNum);
                        if (currentBlockNum - oldestBlockNum > MAX_BLOCK_DIFF)
                            oldestBlockNum = currentBlockNum - MAX_BLOCK_DIFF;
                        blockInc = oldestBlockNum + 1;
                        while (blockInc <= currentBlockNum) {
                            this.eventProcessor.collectBlock(blockInc, true);
                            blockInc += 1;
                        }
                        this.bootupBlockParam = {
                            oldestBlock: oldestBlockNum + 1,
                            currentBlock: currentBlockNum,
                        };
                        console.log("bootup block param: ", this.bootupBlockParam);
                        return [2 /*return*/];
                }
            });
        }); };
        this.startBootup = function () {
            if (_this.bootupStatus !== "running") {
                _this.bootupStatus = "start";
            }
        };
        this.bootup = function () { return __awaiter(_this, void 0, void 0, function () {
            var err_2, err_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        console.log("inside getting blocks to process");
                        return [4 /*yield*/, this.getBlocksToProcess()];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        err_2 = _a.sent();
                        console.log("failed to get blocks to process: ", err_2);
                        this.bootupStatus = "failed";
                        return [2 /*return*/];
                    case 3:
                        _a.trys.push([3, 5, , 6]);
                        console.log("fetching events since last run");
                        return [4 /*yield*/, this.fetchEventsSinceLastRun()];
                    case 4:
                        _a.sent();
                        return [3 /*break*/, 6];
                    case 5:
                        err_3 = _a.sent();
                        console.log("failed to fetch events during bootup: ", err_3);
                        this.bootupStatus = "failed";
                        return [2 /*return*/];
                    case 6:
                        this.setBlocksToReady();
                        this.eventProcessor.setRunTick(true);
                        this.bootupStatus = "succeeded";
                        return [2 /*return*/];
                }
            });
        }); };
        this.addBlocksToWriteInternal = function (blockList) {
            _this.blocksToWriteList = __spreadArray(__spreadArray([], _this.blocksToWriteList, true), blockList, true);
        };
        this.addBlocksToWrite = function (blockList) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.databaseWriter.insert(blockList)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.saveBlocksToDatabase = function () { return __awaiter(_this, void 0, void 0, function () {
            var newBlocksToWrite, maxBlock, i, blockNum, resp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        newBlocksToWrite = this.eventProcessor.getAndClearBlockToWriteList();
                        this.blocksToWriteList = __spreadArray(__spreadArray([], this.blocksToWriteList, true), newBlocksToWrite, true);
                        if (this.blocksToWriteList.length == 0) {
                            return [2 /*return*/];
                        }
                        maxBlock = 0;
                        for (i = 0; i < this.blocksToWriteList.length; i++) {
                            blockNum = this.blocksToWriteList[i];
                            if (blockNum > maxBlock) {
                                maxBlock = blockNum;
                            }
                        }
                        if (maxBlock == 0)
                            return [2 /*return*/];
                        return [4 /*yield*/, this.databaseService.saveProcessedBlocks(
                            // this.blocksToWriteList.map((blockNumber) => ({ blockNumber })),
                            [{ blockNumber: maxBlock, createTime: new Date() }])];
                    case 1:
                        resp = _a.sent();
                        if (!!resp.success) return [3 /*break*/, 3];
                        console.error("saving blocks to database failed: ", resp.data);
                        return [4 /*yield*/, this.systemLogService.addSystemLog({
                                timestamp: new Date(),
                                operation: "bootEventCollectService",
                                message: "".concat((0, utils_1.stringifyTryCatch)(resp.data)),
                                logType: "operation",
                            })];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        this.blocksToWriteList = [];
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        }); };
        this.update = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.bootupStatus === "start") {
                            this.bootupStatus = "running";
                            console.log("booting up");
                            this.bootup();
                        }
                        return [4 /*yield*/, this.databaseWriter.execute()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.databaseService = databaseService;
        this.contractService = contractService;
        this.eventProcessor = eventProcessor;
        this.web3Service = web3Service;
        this.systemLogService = systemLogService;
    }
    return BootEventCollectService;
}());
exports.BootEventCollectService = BootEventCollectService;
