"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractService = void 0;
var ethers_1 = require("ethers");
var envConfig_1 = require("../config/envConfig");
var OrderPayment_1 = __importDefault(require("../config/abi/OrderPayment"));
var ContractService = /** @class */ (function () {
    function ContractService(web3Service) {
        var _this = this;
        this.setup = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, CONT_GETAPPLIST_LIMIT, CONT_GETBALTIME_LIMIT;
            return __generator(this, function (_b) {
                _a = envConfig_1.envConfig.SYSTEM_ENV, CONT_GETAPPLIST_LIMIT = _a.CONT_GETAPPLIST_LIMIT, CONT_GETBALTIME_LIMIT = _a.CONT_GETBALTIME_LIMIT;
                this.setupContracts(this.web3Service.signer);
                return [2 /*return*/];
            });
        }); };
        // getAppListInternal = async (param: {
        //     nftID: string;
        //     blockNumber: number;
        // }): Promise<APICallReturn<AppParam[], Error>> => {
        //     const { nftID, blockNumber } = param;
        //     // const AppDeployment = this.getAppDeployment();
        //     const result = await apiCallWrapper<any, AppParam[]>(
        //         AppDeployment.getAppList(nftID),
        //         (contractAppList) =>
        //             contractAppList
        //                 .map((app) => formatAppParams(blockNumber, nftID, app))
        //                 .map((app) => {
        //                     return {
        //                         ...app,
        //                         appName: convertAppName(app.appName),
        //                         appPath: convertPath(app.appPath),
        //                         modPath: convertPath(app.modPath),
        //                     };
        //                 }),
        //     );
        //     return result;
        // };
        // getAppList = async (param: {
        //     nftID: string;
        //     blockNumber: number;
        // }): Promise<APICallReturn<AppParam[]>> => {
        //     return await this.appListMutex.execute(param);
        // };
        // getBalanceEndTimeInternal = async (
        //     nftID: string,
        // ): Promise<APICallReturn<Date>> => {
        //     const result = await apiCallWrapper<bigint, Date>(
        //         this.getSubscriptionBalance().getBalanceEndTime(nftID),
        //         (balanceEndTime) => new Date(Number(balanceEndTime) * 1000),
        //     );
        //     return result;
        // };
        // getBalanceEndTime = async (nftID: string): Promise<APICallReturn<Date>> => {
        //     return await this.balanceTimeMutex.execute(nftID);
        // };
        this.setupContracts = function (signer) {
            var socketProvider = _this.web3Service.getSocketProvider();
            var OrderPayment = envConfig_1.envConfig.CONTRACT_ADDRESSES.OrderPayment;
            _this.OrderPayment = new ethers_1.ethers.Contract(OrderPayment, OrderPayment_1.default, signer);
            // this.AppDeployment = new ethers.Contract(
            //     AppDeployment,
            //     AppDeploymentABI,
            //     signer,
            // );
            // this.SubscriptionBalance = new ethers.Contract(
            //     SubscriptionBalance,
            //     SubscriptionBalanceABI,
            //     signer,
            // );
            // this.SubnetCluster = new ethers.Contract(
            //     Registration,
            //     SubnetClusterABI,
            //     signer,
            // );
        };
        // getAppDeployment = () => {
        //     return this.AppDeployment;
        // };
        // getSubscriptionBalance = () => {
        //     return this.SubscriptionBalance;
        // };
        // getSubnetCluster = () => {
        //     return this.SubnetCluster;
        // };
        this.getOrderPayment = function () {
            return _this.OrderPayment;
        };
        this.web3Service = web3Service;
    }
    return ContractService;
}());
exports.ContractService = ContractService;
