import { APICallReturn, BlockNumber, HeartBeat, SystemLog } from "../types/types";
import { Collection, Db, MongoClient } from "mongodb";
export declare class DatabaseService {
    client: MongoClient;
    database: Db;
    collection: {
        processedBlocks: Collection<BlockNumber>;
        systemLogs: Collection<SystemLog>;
        heartBeat: Collection<HeartBeat>;
    };
    setup: () => Promise<void>;
    startTransaction: () => () => Promise<APICallReturn<any, Error>>;
    saveProcessedBlocks: (blockList: BlockNumber[]) => Promise<APICallReturn<number>>;
    getMaxProcessedBlock: () => Promise<APICallReturn<BlockNumber | null>>;
    insertSystemLogs: (systemLogList: SystemLog[]) => Promise<APICallReturn<number>>;
    getAllSysLogs: () => Promise<APICallReturn<SystemLog[]>>;
    updateHeartBeat: (heartBeat: HeartBeat) => Promise<APICallReturn<string>>;
    getHeartBeat: () => Promise<APICallReturn<HeartBeat>>;
    setupDatabase: () => Promise<void>;
}
