"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatabaseService = void 0;
var envConfig_1 = require("../config/envConfig");
var mongodb_1 = require("mongodb");
var utils_1 = require("../utils/utils");
var DatabaseService = /** @class */ (function () {
    function DatabaseService() {
        var _this = this;
        this.setup = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setupDatabase()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.startTransaction = function () {
            var session = _this.client.startSession();
            session.startTransaction({
                readConcern: { level: "snapshot" },
                writeConcern: { w: "majority" },
            });
            return function () {
                return (0, utils_1.apiCallWrapper)(session.commitTransaction(), function (res) { return res; });
            };
        };
        this.saveProcessedBlocks = function (blockList) { return __awaiter(_this, void 0, void 0, function () {
            var options, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = { ordered: true };
                        return [4 /*yield*/, (0, utils_1.apiCallWrapper)(this.collection.processedBlocks.insertMany(blockList, options), function (res) { return (res.acknowledged ? res.insertedCount : 0); })];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        }); };
        this.getMaxProcessedBlock = function () { return __awaiter(_this, void 0, void 0, function () {
            var cursor, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cursor = this.collection.processedBlocks
                            .find({})
                            .sort({ blockNumber: -1 });
                        return [4 /*yield*/, (0, utils_1.apiCallWrapper)(cursor.next(), function (res) { return res; })];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        }); };
        this.insertSystemLogs = function (systemLogList) { return __awaiter(_this, void 0, void 0, function () {
            var options, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        options = { ordered: true };
                        return [4 /*yield*/, (0, utils_1.apiCallWrapper)(this.collection.systemLogs.insertMany(systemLogList, options), function (res) { return (res.acknowledged ? res.insertedCount : 0); })];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        }); };
        this.getAllSysLogs = function () { return __awaiter(_this, void 0, void 0, function () {
            var cursor, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        cursor = this.collection.systemLogs
                            .find({})
                            .sort({ timestamp: 1 });
                        return [4 /*yield*/, (0, utils_1.apiCallWrapper)(cursor.toArray(), function (res) { return res; })];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        }); };
        this.updateHeartBeat = function (heartBeat) { return __awaiter(_this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, (0, utils_1.apiCallWrapper)(this.collection.heartBeat.updateOne({}, {
                            $set: heartBeat,
                        }, {
                            upsert: true,
                        }), function (res) { return ""; })];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        }); };
        this.getHeartBeat = function () { return __awaiter(_this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, (0, utils_1.apiCallWrapper)(this.collection.heartBeat.findOne({}), function (res) { return res; })];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result];
                }
            });
        }); };
        this.setupDatabase = function () { return __awaiter(_this, void 0, void 0, function () {
            var MONGODB_URL, MONGODB_DBNAME, _a, BLOCK_TIME, MAX_BLOCK_DIFF, client, database, processedBlocks, indexExists, systemLogs, lastBalanceScanTime, heartBeat;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        MONGODB_URL = envConfig_1.envConfig.MONGODB_URL, MONGODB_DBNAME = envConfig_1.envConfig.MONGODB_DBNAME;
                        _a = envConfig_1.envConfig.SYSTEM_ENV, BLOCK_TIME = _a.BLOCK_TIME, MAX_BLOCK_DIFF = _a.MAX_BLOCK_DIFF;
                        return [4 /*yield*/, mongodb_1.MongoClient.connect(MONGODB_URL)];
                    case 1:
                        client = _b.sent();
                        console.log("created database client: ".concat(MONGODB_URL));
                        database = client.db(MONGODB_DBNAME);
                        console.log("connected to database: ".concat(MONGODB_DBNAME));
                        processedBlocks = database.collection("processedBlocks");
                        return [4 /*yield*/, processedBlocks.indexExists("createTime_1")];
                    case 2:
                        indexExists = _b.sent();
                        console.log("processedblocks index: ", indexExists);
                        if (!!indexExists) return [3 /*break*/, 4];
                        return [4 /*yield*/, processedBlocks.createIndex({ createTime: 1 }, {
                                expireAfterSeconds: BLOCK_TIME * MAX_BLOCK_DIFF + 60 * 60 * 24,
                            })];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        systemLogs = database.collection("systemLogs");
                        lastBalanceScanTime = database.collection("lastBalanceScanTime");
                        heartBeat = database.collection("heartBeat");
                        this.collection = {
                            processedBlocks: processedBlocks,
                            systemLogs: systemLogs,
                            heartBeat: heartBeat,
                        };
                        this.client = client;
                        this.database = database;
                        console.log("database setup done");
                        return [2 /*return*/];
                }
            });
        }); };
    }
    return DatabaseService;
}());
exports.DatabaseService = DatabaseService;
