/// <reference types="node" />
import { NFTEventProcessor } from "../events/eventProcessor";
import { SystemLogService } from "./systemLogService";
import { Web3Service } from "../config/ethersConfig";
import { ContractService } from "./contractService";
import { BootEventCollectService } from "./bootEventCollectService";
import { Domain } from "domain";
import { ListenerService } from "../utils/listenerService";
export declare class EthersListenerService implements ListenerService {
    web3Service: Web3Service;
    contractService: ContractService;
    eventProcessor: NFTEventProcessor;
    systemLogService: SystemLogService;
    bootupEventCollectService: BootEventCollectService;
    socketDomain: Domain;
    startFlag: boolean;
    errorCount: number;
    startSetTime: Date;
    domainErrorTime: Date;
    constructor(web3Service: Web3Service, contractService: ContractService, eventProcessor: NFTEventProcessor, systemLogService: SystemLogService, bootupEventCollectService: BootEventCollectService);
    getPaymentReceivedParam: (args: any, contractPayload: any) => import("../types/types").PaymentReceivedParam;
    createListeners: () => Promise<void>;
    startListeners: () => Promise<void>;
}
