"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EthersListenerService = void 0;
var envConfig_1 = require("../config/envConfig");
var domain_1 = __importDefault(require("domain"));
var utils_1 = require("../utils/utils");
var EthersListenerService = /** @class */ (function () {
    function EthersListenerService(web3Service, contractService, eventProcessor, systemLogService, bootupEventCollectService) {
        var _this = this;
        this.startFlag = true;
        this.errorCount = 0;
        this.startSetTime = new Date();
        this.domainErrorTime = new Date();
        this.getPaymentReceivedParam = function (args, contractPayload) {
            // const { log } = contractPayload;
            // const filter = log.topics[0];
            // const { blockNumber } = log;
            var filter = contractPayload.topics[0];
            var blockNumber = contractPayload.blockNumber;
            console.log("filter: ", _this.eventProcessor.filterToParamMap);
            if (_this.eventProcessor.filterToParamMap[filter]) {
                return _this.eventProcessor.filterToParamMap[filter](blockNumber, args);
            }
            return null;
        };
        this.createListeners = function () { return __awaiter(_this, void 0, void 0, function () {
            var SUBNET_ID, LISTSERV_BLOCKADD_TIME_1, firstPingReceived_1, timeToWriteBlock_1, httpProvider, OrderPayment, error;
            var _this = this;
            return __generator(this, function (_a) {
                try {
                    SUBNET_ID = envConfig_1.envConfig.SUBNET_ID;
                    LISTSERV_BLOCKADD_TIME_1 = envConfig_1.envConfig.SYSTEM_ENV.LISTSERV_BLOCKADD_TIME;
                    firstPingReceived_1 = false;
                    timeToWriteBlock_1 = new Date();
                    httpProvider = this.web3Service.getHTTPProvider();
                    OrderPayment = this.contractService.OrderPayment;
                    console.log("createListeners");
                    OrderPayment.on("*", function (contractPayload) { return __awaiter(_this, void 0, void 0, function () {
                        var args, paymentReceived, err_1, error;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    console.log("contract payload: ", contractPayload, firstPingReceived_1);
                                    if (!firstPingReceived_1)
                                        return [2 /*return*/];
                                    _a.label = 1;
                                case 1:
                                    _a.trys.push([1, 3, , 5]);
                                    args = contractPayload.args;
                                    paymentReceived = this.getPaymentReceivedParam(args, contractPayload);
                                    console.log("paymentReceived: ", paymentReceived);
                                    if (!paymentReceived)
                                        return [2 /*return*/];
                                    return [4 /*yield*/, this.eventProcessor.collectEvents(false, [
                                            paymentReceived,
                                        ])];
                                case 2:
                                    _a.sent();
                                    return [3 /*break*/, 5];
                                case 3:
                                    err_1 = _a.sent();
                                    error = err_1;
                                    console.log("error: ", error);
                                    return [4 /*yield*/, this.systemLogService.addSystemLog({
                                            timestamp: new Date(),
                                            operation: "listenerService",
                                            message: error.message,
                                            logType: "error",
                                        })];
                                case 4:
                                    _a.sent();
                                    return [3 /*break*/, 5];
                                case 5: return [2 /*return*/];
                            }
                        });
                    }); });
                    httpProvider.on("block", function (blockNumber) { return __awaiter(_this, void 0, void 0, function () {
                        var curTime;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    curTime = new Date();
                                    // console.log("received block: ", blockNumber);
                                    if (firstPingReceived_1 == false) {
                                        firstPingReceived_1 = true;
                                        console.log("first ping received");
                                        this.bootupEventCollectService.startBootup();
                                        return [2 /*return*/];
                                    }
                                    if (!(timeToWriteBlock_1.getTime() + LISTSERV_BLOCKADD_TIME_1 <
                                        curTime.getTime())) return [3 /*break*/, 2];
                                    return [4 /*yield*/, this.eventProcessor.collectBlock(blockNumber, false)];
                                case 1:
                                    _a.sent();
                                    timeToWriteBlock_1 = new Date();
                                    _a.label = 2;
                                case 2: return [2 /*return*/];
                            }
                        });
                    }); });
                }
                catch (err) {
                    error = err;
                    console.log("error in socket service: ", error);
                }
                return [2 /*return*/];
            });
        }); };
        this.startListeners = function () { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                this.socketDomain = domain_1.default.create();
                console.log("outside domain");
                this.socketDomain.on("error", function (er) {
                    if (this.domainErrorTime.getTime() > new Date().getTime())
                        return;
                    this.errorCount += 1;
                    console.log("domain errored out: ", this.errorCount);
                    this.domainErrorTime = new Date(new Date().getTime() + 15000);
                    setTimeout(function () {
                        console.log("set the start flag to true");
                        this.startFlag = true;
                    }, 15000);
                });
                this.socketDomain.run(function () { return __awaiter(_this, void 0, void 0, function () {
                    var nextRunTime, RUN_DURATION, curTime, sleepDur;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                console.log("domain running");
                                nextRunTime = new Date().getTime();
                                RUN_DURATION = 1000;
                                _a.label = 1;
                            case 1:
                                if (!true) return [3 /*break*/, 3];
                                curTime = new Date().getTime();
                                sleepDur = nextRunTime - curTime;
                                return [4 /*yield*/, (0, utils_1.sleep)(sleepDur)];
                            case 2:
                                _a.sent();
                                nextRunTime = new Date().getTime() + RUN_DURATION;
                                if (this.startFlag == true) {
                                    if (this.startSetTime.getTime() - new Date().getTime() <
                                        10000) {
                                        this.startSetTime = new Date();
                                        this.startFlag = false;
                                        this.createListeners();
                                    }
                                    console.log("inside true start flag: ", this.errorCount);
                                    this.errorCount -= 1;
                                }
                                return [3 /*break*/, 1];
                            case 3: return [2 /*return*/];
                        }
                    });
                }); });
                return [2 /*return*/];
            });
        }); };
        this.web3Service = web3Service;
        this.contractService = contractService;
        this.eventProcessor = eventProcessor;
        this.systemLogService = systemLogService;
        this.bootupEventCollectService = bootupEventCollectService;
    }
    return EthersListenerService;
}());
exports.EthersListenerService = EthersListenerService;
