"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeartBeatService = void 0;
var envConfig_1 = require("../config/envConfig");
var databaseWriterExecution_1 = require("../utils/databaseWriterExecution");
var utils_1 = require("../utils/utils");
var HeartBeatService = /** @class */ (function () {
    function HeartBeatService(databaseService, systemLogService) {
        var _this = this;
        this.setup = function () { return __awaiter(_this, void 0, void 0, function () {
            var HEARTBEAT_DURATION;
            return __generator(this, function (_a) {
                HEARTBEAT_DURATION = envConfig_1.envConfig.SYSTEM_ENV.HEARTBEAT_DURATION;
                this.databaseWriter = new databaseWriterExecution_1.DatabaseWriterExecution("heartBeat", this.pushHeartBeatToDatabase, null, HEARTBEAT_DURATION);
                return [2 /*return*/];
            });
        }); };
        this.pushHeartBeatToDatabase = function () { return __awaiter(_this, void 0, void 0, function () {
            var heartBeat, resp;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        heartBeat = {
                            heartBeatTime: new Date(),
                        };
                        return [4 /*yield*/, this.databaseService.updateHeartBeat(heartBeat)];
                    case 1:
                        resp = _a.sent();
                        if (!!resp.success) return [3 /*break*/, 3];
                        console.error("failed to push heartbeat to database: ", resp.data);
                        return [4 /*yield*/, this.systemLogService.addSystemLog({
                                timestamp: new Date(),
                                operation: "heartBeatService",
                                message: "".concat((0, utils_1.stringifyTryCatch)(resp.data)),
                                logType: "operation",
                            })];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        }); };
        this.update = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.databaseWriter.execute()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.databaseService = databaseService;
        this.systemLogService = systemLogService;
    }
    return HeartBeatService;
}());
exports.HeartBeatService = HeartBeatService;
