import { NFTEventProcessor } from "../events/eventProcessor";
import { Web3Service } from "../config/ethersConfig";
import { APICallReturn, NFTEvent, SystemLog } from "../types/types";
import { DatabaseService } from "./databaseService";
import { BootEventCollectService } from "./bootEventCollectService";
import { SystemLogService } from "./systemLogService";
import { ContractService } from "./contractService";
import { HeartBeatService } from "./heartBeatService";
import { ProcessCheckService } from "./processCheckService";
export declare class Main {
    RUN_DURATION: number;
    nextRunTime: number;
    web3Service: Web3Service;
    contractService: ContractService;
    eventProcessor: NFTEventProcessor;
    databaseService: DatabaseService;
    bootupEventCollectService: BootEventCollectService;
    systemLogService: SystemLogService;
    heartBeatService: HeartBeatService;
    processCheckService: ProcessCheckService;
    constructor(callFunc: (nftEvent: NFTEvent) => Promise<APICallReturn<number[]>>);
    addSetupLog: (type: SystemLog["logType"], message: string) => Promise<void>;
    addUpdateLog: (type: SystemLog["logType"], message: string) => Promise<void>;
    setup: () => Promise<boolean>;
    update: () => Promise<never>;
}
