"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Main = void 0;
var eventProcessor_1 = require("../events/eventProcessor");
var ethersConfig_1 = require("../config/ethersConfig");
var envConfig_1 = require("../config/envConfig");
var databaseService_1 = require("./databaseService");
var utils_1 = require("../utils/utils");
var bootEventCollectService_1 = require("./bootEventCollectService");
var systemLogService_1 = require("./systemLogService");
var contractService_1 = require("./contractService");
var heartBeatService_1 = require("./heartBeatService");
var processCheckService_1 = require("./processCheckService");
var Main = /** @class */ (function () {
    function Main(callFunc) {
        var _this = this;
        this.addSetupLog = function (type, message) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.systemLogService.addSystemLog({
                            timestamp: new Date(),
                            operation: "main.setup",
                            message: message,
                            logType: type,
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.addUpdateLog = function (type, message) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.systemLogService.addSystemLog({
                            timestamp: new Date(),
                            operation: "main.update",
                            message: message,
                            logType: type,
                        })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); };
        this.setup = function () { return __awaiter(_this, void 0, void 0, function () {
            var UPDATE_DURATION, err_1, error;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 9, , 10]);
                        envConfig_1.envConfig.setupENV();
                        return [4 /*yield*/, this.systemLogService.setup()];
                    case 1:
                        _a.sent();
                        this.addSetupLog("operation", "ENV: ".concat((0, utils_1.stringifyTryCatch)(envConfig_1.envConfig)));
                        UPDATE_DURATION = envConfig_1.envConfig.SYSTEM_ENV.UPDATE_DURATION;
                        this.RUN_DURATION = UPDATE_DURATION;
                        return [4 /*yield*/, this.heartBeatService.setup()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.databaseService.setup()];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.web3Service.setup()];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, this.contractService.setup()];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, this.eventProcessor.setup()];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, this.bootupEventCollectService.setup()];
                    case 7:
                        _a.sent();
                        return [4 /*yield*/, this.processCheckService.setup()];
                    case 8:
                        _a.sent();
                        return [2 /*return*/, true];
                    case 9:
                        err_1 = _a.sent();
                        error = err_1;
                        console.log("main setup error: ", error);
                        return [2 /*return*/, false];
                    case 10: return [2 /*return*/];
                }
            });
        }); };
        this.update = function () { return __awaiter(_this, void 0, void 0, function () {
            var curTime, sleepDur, err_2, error;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!true) return [3 /*break*/, 11];
                        curTime = new Date().getTime();
                        sleepDur = this.nextRunTime - curTime;
                        return [4 /*yield*/, (0, utils_1.sleep)(sleepDur)];
                    case 1:
                        _a.sent();
                        this.nextRunTime = new Date().getTime() + this.RUN_DURATION;
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 8, , 10]);
                        return [4 /*yield*/, this.eventProcessor.update()];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.bootupEventCollectService.update()];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, this.processCheckService.update()];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, this.systemLogService.update()];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, this.heartBeatService.update()];
                    case 7:
                        _a.sent();
                        return [3 /*break*/, 10];
                    case 8:
                        err_2 = _a.sent();
                        error = err_2;
                        console.error("error in update: ", error);
                        return [4 /*yield*/, this.addUpdateLog("error", error.message)];
                    case 9:
                        _a.sent();
                        return [3 /*break*/, 10];
                    case 10: return [3 /*break*/, 0];
                    case 11: return [2 /*return*/];
                }
            });
        }); };
        this.RUN_DURATION = 0;
        this.nextRunTime = new Date().getTime();
        this.web3Service = new ethersConfig_1.Web3Service();
        this.contractService = new contractService_1.ContractService(this.web3Service);
        this.databaseService = new databaseService_1.DatabaseService();
        this.systemLogService = new systemLogService_1.SystemLogService(this.databaseService);
        this.eventProcessor = new eventProcessor_1.NFTEventProcessor(this.contractService, callFunc);
        this.bootupEventCollectService = new bootEventCollectService_1.BootEventCollectService(this.databaseService, this.contractService, this.eventProcessor, this.web3Service, this.systemLogService);
        this.heartBeatService = new heartBeatService_1.HeartBeatService(this.databaseService, this.systemLogService);
        this.processCheckService = new processCheckService_1.ProcessCheckService(this.systemLogService);
    }
    return Main;
}());
exports.Main = Main;
