import { APICallReturn } from "../types/types";
import STKETHKeyEncrypter from "@decloudlabs/stk-v2/lib/services/STKSecretKeyEncrypter";
import * as sigUtil from "@metamask/eth-sig-util";
import { ethers } from "ethers";
export default class STKSecretKeyEncrypter extends STKETHKeyEncrypter {
    secretKey: string;
    signer: ethers.Wallet;
    constructor(secretKey: string, signer: ethers.Wallet);
    encrypt(data: string): Promise<APICallReturn<Uint8Array>>;
    encryptWithPublicKey(data: string, publicKey: string): Promise<APICallReturn<Uint8Array>>;
    getEncryptionPublicKey(): Promise<APICallReturn<string>>;
    decrypt(data: Uint8Array): Promise<APICallReturn<string>>;
    sign(newTypedMessage: sigUtil.TypedMessage<sigUtil.MessageTypes>): Promise<APICallReturn<{
        signature: string;
    }>>;
}
