"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var STKSecretKeyEncrypter_1 = __importDefault(require("@decloudlabs/stk-v2/lib/services/STKSecretKeyEncrypter"));
var sigUtil = __importStar(require("@metamask/eth-sig-util"));
var nacl = __importStar(require("tweetnacl"));
var naclUtil = __importStar(require("tweetnacl-util"));
var STKSecretKeyEncrypter = /** @class */ (function (_super) {
    __extends(STKSecretKeyEncrypter, _super);
    function STKSecretKeyEncrypter(secretKey, signer) {
        var _this = _super.call(this, secretKey) || this;
        _this.secretKey = secretKey;
        _this.signer = signer;
        return _this;
    }
    STKSecretKeyEncrypter.prototype.encrypt = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var publicKey, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getEncryptionPublicKey()];
                    case 1:
                        publicKey = _a.sent();
                        if (publicKey.success) {
                            result = sigUtil.encrypt({
                                publicKey: publicKey.data,
                                data: data,
                                version: "x25519-xsalsa20-poly1305",
                            });
                            return [2 /*return*/, {
                                    success: true,
                                    data: Uint8Array.from(Buffer.from(JSON.stringify(result), "utf8")),
                                }];
                        }
                        else {
                            return [2 /*return*/, {
                                    success: false,
                                    data: Error("Failed to get encryption public key"),
                                }];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    STKSecretKeyEncrypter.prototype.encryptWithPublicKey = function (data, publicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, sigUtil.encrypt({
                            publicKey: publicKey,
                            data: data,
                            version: "x25519-xsalsa20-poly1305",
                        })];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, {
                                success: true,
                                data: Uint8Array.from(Buffer.from(JSON.stringify(result), "utf8")),
                            }];
                }
            });
        });
    };
    STKSecretKeyEncrypter.prototype.getEncryptionPublicKey = function () {
        return __awaiter(this, void 0, void 0, function () {
            var skBuff, keyPair;
            return __generator(this, function (_a) {
                try {
                    skBuff = new Uint8Array(Buffer.from(this.secretKey, "hex"));
                    keyPair = nacl.box.keyPair.fromSecretKey(skBuff);
                    return [2 /*return*/, {
                            success: true,
                            data: naclUtil.encodeBase64(keyPair.publicKey),
                        }];
                }
                catch (e) {
                    return [2 /*return*/, {
                            success: false,
                            data: e,
                        }];
                }
                return [2 /*return*/];
            });
        });
    };
    STKSecretKeyEncrypter.prototype.decrypt = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var dec, encryptedAppString, ethEncryptedData, result;
            return __generator(this, function (_a) {
                try {
                    dec = new TextDecoder("utf-8");
                    encryptedAppString = dec.decode(data);
                    ethEncryptedData = JSON.parse(encryptedAppString);
                    result = sigUtil.decrypt({
                        encryptedData: ethEncryptedData,
                        privateKey: this.secretKey,
                    });
                    return [2 /*return*/, {
                            success: true,
                            data: result,
                        }];
                }
                catch (e) {
                    return [2 /*return*/, {
                            success: false,
                            data: e,
                        }];
                }
                return [2 /*return*/];
            });
        });
    };
    STKSecretKeyEncrypter.prototype.sign = function (newTypedMessage) {
        return __awaiter(this, void 0, void 0, function () {
            var signature, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.signer.signMessage(JSON.stringify(newTypedMessage))];
                    case 1:
                        signature = _a.sent();
                        // const signature = signTypedData({
                        //     privateKey: Buffer.from(this.secretKey, "hex"),
                        //     data: newTypedMessage,
                        //     version: SignTypedDataVersion.V4,
                        // });
                        return [2 /*return*/, {
                                success: true,
                                data: { signature: signature },
                            }];
                    case 2:
                        err_1 = _a.sent();
                        return [2 /*return*/, {
                                success: false,
                                data: err_1,
                            }];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    return STKSecretKeyEncrypter;
}(STKSecretKeyEncrypter_1.default));
exports.default = STKSecretKeyEncrypter;
