"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Mutex = /** @class */ (function () {
    function Mutex() {
        this.queue = [];
        this.locked = false;
    }
    Mutex.prototype.lock = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            if (_this.locked) {
                _this.queue.push([resolve, reject]);
            }
            else {
                _this.locked = true;
                resolve();
            }
        });
    };
    Mutex.prototype.release = function () {
        if (this.queue.length > 0) {
            var _a = this.queue.shift(), resolve = _a[0], reject = _a[1];
            resolve();
        }
        else {
            this.locked = false;
        }
    };
    return Mutex;
}());
exports.default = Mutex;
