import { APICallReturn, AppParam, BalanceAddedParam, BalanceWithdrawnParam, FetchedContractApp, DeleteAppParam, PaymentReceivedParam } from "../types/types";
export declare function sleep(ms: number): Promise<unknown>;
export declare const convertDeleteAppParam: (blockNumber: number, param: any[]) => DeleteAppParam;
export declare const convertBalanceAddedParam: (blockNumber: number, param: any[]) => BalanceAddedParam;
export declare const convertBalanceWithdrawnParam: (blockNumber: number, param: any[]) => BalanceWithdrawnParam;
export declare const convertAppName: (appName: string) => string;
export declare const convertPath: (path: string) => string;
export declare const formatAppParams: (blockNumber: number, nftID: string, contractApp: FetchedContractApp) => AppParam;
export declare const convertPaymentReceivedParam: (blockNumber: number, param: any[]) => PaymentReceivedParam;
export declare const convertCreateAppParam: (blockNumber: number, param: any[]) => AppParam;
export declare const convertCreateAppBatchParam: (blockNumber: number, param: any[]) => AppParam[];
export declare const convertUpdateAppBatchParam: (blockNumber: number, param: any[]) => AppParam[];
export declare const convertUpdateAppParam: (blockNumber: number, param: any[]) => AppParam;
export declare const getEventABI: (ContractABI: any[], eventName: string) => any;
export declare const dateToCron: (date: Date) => string;
type APIResponse<K, E> = {
    resp: K;
    success: true;
} | {
    resp: E;
    success: false;
};
export declare const apiCallWrapper: <K, T, E = Error>(apiCall: Promise<K>, format?: (rowList: K) => T, modifyRet?: (param: APIResponse<K, E>) => APICallReturn<T, E>) => Promise<APICallReturn<T, E>>;
export declare const statusCheckCallWrapper: <K, T, E = Error>(apiCall: Promise<K>, getStatusCode: (param: APIResponse<K, E>) => number, format?: (rowList: K) => T, modifyRet?: (param: APIResponse<K, E>) => APICallReturn<T, E>) => Promise<APICallReturn<T, E>>;
export declare const isValidCPUInstance: (resourceType: number[]) => {
    status: boolean;
    index: any;
    message?: undefined;
} | {
    status: boolean;
    message: string;
    index?: undefined;
};
export declare const stringifyTryCatch: (data: any) => string;
export {};
