"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringifyTryCatch = exports.isValidCPUInstance = exports.statusCheckCallWrapper = exports.apiCallWrapper = exports.dateToCron = exports.getEventABI = exports.convertUpdateAppParam = exports.convertUpdateAppBatchParam = exports.convertCreateAppBatchParam = exports.convertCreateAppParam = exports.convertPaymentReceivedParam = exports.formatAppParams = exports.convertPath = exports.convertAppName = exports.convertBalanceWithdrawnParam = exports.convertBalanceAddedParam = exports.convertDeleteAppParam = exports.sleep = void 0;
var constant_1 = require("../constant/constant");
function sleep(ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
}
exports.sleep = sleep;
var hexToString = function (hexx) {
    var hex = hexx.toString();
    var str = "";
    for (var i = 0; i < hex.length; i += 2) {
        var val = String.fromCharCode(parseInt(hex.substr(i, 2), 16));
        if (val.charCodeAt(0) > 0) {
            str += val;
        }
    }
    return str;
};
var convertDeleteAppParam = function (blockNumber, param) {
    // const nftID = param[0];
    // const appID = param[1];
    var PARAMID = {
        nftID: 0,
        appID: 1,
        appName: 2,
        subnetList: 3,
        multiplier: 4,
        resourceCount: 5,
        resourceType: 6,
    };
    var nftID = param[PARAMID.nftID].toString();
    var appID = param[PARAMID.appID].toString();
    // const [appPath, modPath] = param[PARAMID.path];
    var appName = param[PARAMID.appName];
    appName = hexToString(appName);
    var subnetList = param[PARAMID.subnetList].map(function (t) {
        return t.toString();
    });
    var multiplier = param[PARAMID.multiplier].map(function (arr) {
        return arr.map(function (e) { return Number(e); });
    });
    var resourceCount = param[PARAMID.resourceCount].map(function (e) { return Number(e); });
    var resourceType = param[PARAMID.resourceType].map(function (e) { return Number(e); });
    var convertParam = {
        blockNumber: blockNumber,
        // eventID: NFT_EVENT_ID_MAP.DELETE_APP,
        eventType: "delete",
        nftID: nftID,
        appID: appID,
        appName: appName,
        // appPath: "",
        // modPath: "",
        subnetList: subnetList,
        // multiplier,
        // resourceCount,
        // resourceType,
    };
    return convertParam;
};
exports.convertDeleteAppParam = convertDeleteAppParam;
var convertBalanceAddedParam = function (blockNumber, param) {
    var nftID = param[0].toString();
    return {
        blockNumber: blockNumber,
        // eventID: NFT_EVENT_ID_MAP.BALANCE_ADDED,
        eventType: "balance-added",
        nftID: nftID,
    };
};
exports.convertBalanceAddedParam = convertBalanceAddedParam;
var convertBalanceWithdrawnParam = function (blockNumber, param) {
    var nftID = param[0].toString();
    return {
        blockNumber: blockNumber,
        eventType: "balance-withdrawn",
        nftID: nftID,
    };
};
exports.convertBalanceWithdrawnParam = convertBalanceWithdrawnParam;
var convertAppName = function (appName) {
    return hexToString(appName);
};
exports.convertAppName = convertAppName;
var convertPath = function (path) {
    // path = Buffer.from(path.substring(2), "hex").toString();
    // path = path.substring(1);
    path = path.substring(2);
    return path;
};
exports.convertPath = convertPath;
var formatAppParams = function (blockNumber, nftID, contractApp) {
    var app = {
        nftID: nftID,
        blockNumber: blockNumber,
        // eventID: NFT_EVENT_ID_MAP.UPDATE_APP,
        eventType: "update",
        appID: contractApp[0].toString(),
        subnetList: contractApp[1].map(function (subnetID) { return subnetID.toString(); }),
        multiplier: contractApp[2].map(function (mulArr) {
            return mulArr.map(function (mul) { return Number(mul); });
        }),
        appName: contractApp[3][0],
        appPath: contractApp[3][2][0],
        modPath: contractApp[3][2][1],
        resourceCount: contractApp[3][3].map(function (res) { return Number(res); }),
        resourceType: contractApp[3][4].map(function (res) { return Number(res); }),
    };
    return app;
};
exports.formatAppParams = formatAppParams;
var convertPaymentReceivedParam = function (blockNumber, param) {
    // event PaymentReceived(uint256 indexed orderID, uint256 amount, string collectionId, uint256 mintCount, address _recieverAddress, string filePath);
    // export interface PaymentReceivedParam extends BaseParam {
    //     eventType: "payment-received";
    //     orderID: string;
    //     collectionID: string;
    //     amount: string;
    //     mintCount: number;
    //     receiverAddress: ETHAddress;
    //     filePath: string;
    // }
    return {
        blockNumber: blockNumber,
        eventType: "payment-received",
        orderID: param[0].toString(),
        amount: param[1].toString(),
        collectionID: param[2].toString(),
        mintCount: param[3].toNumber(),
        receiverAddress: param[4].toString(),
        filePath: param[5].toString(),
    };
};
exports.convertPaymentReceivedParam = convertPaymentReceivedParam;
var convertCreateAppParam = function (blockNumber, param) {
    var PARAMID = {
        nftID: 0,
        appID: 1,
        appName: 2,
        path: 3,
        subnetList: 4,
        multiplier: 5,
        resourceCount: 6,
        resourceType: 7,
    };
    var nftID = param[PARAMID.nftID].toString();
    var appID = param[PARAMID.appID].toString();
    var _a = param[PARAMID.path], appPath = _a[0], modPath = _a[1];
    // appPath = Buffer.from(appPath.substring(2), "hex").toString();
    // appPath = appPath.substring(1);
    // modPath = Buffer.from(modPath.substring(2), "hex").toString();
    // modPath = modPath.substring(1);
    appPath = (0, exports.convertPath)(appPath);
    modPath = (0, exports.convertPath)(modPath);
    var appName = param[PARAMID.appName];
    appName = hexToString(appName);
    var subnetList = param[PARAMID.subnetList].map(function (t) {
        return t.toString();
    });
    var multiplier = param[PARAMID.multiplier].map(function (arr) { return arr.map(function (e) { return Number(e); }); });
    var resourceCount = param[PARAMID.resourceCount].map(function (e) { return Number(e); });
    var resourceType = param[PARAMID.resourceType].map(function (e) { return Number(e); });
    var convertParam = {
        blockNumber: blockNumber,
        // eventID: NFT_EVENT_ID_MAP.CREATE_APP,
        eventType: "update",
        nftID: nftID,
        appID: appID,
        appName: appName,
        appPath: appPath,
        modPath: modPath,
        subnetList: subnetList,
        multiplier: multiplier,
        resourceCount: resourceCount,
        resourceType: resourceType,
    };
    return convertParam;
};
exports.convertCreateAppParam = convertCreateAppParam;
var convertCreateAppBatchParam = function (blockNumber, param) {
    var PARAMID = {
        nftID: 0,
        appID: 1,
        appName: 2,
        path: 3,
        subnetList: 4,
        multiplier: 5,
        resourceCount: 6,
        resourceType: 7,
    };
    var nftID = param[PARAMID.nftID].toString();
    var appIDList = param[PARAMID.appID];
    var appPathList = param[PARAMID.path];
    var appNameList = param[PARAMID.appName];
    var appSubnetList = param[PARAMID.subnetList];
    var appMultiplier = param[PARAMID.multiplier];
    var appResourceCount = param[PARAMID.resourceCount];
    var appResourceType = param[PARAMID.resourceType];
    var appParamList = [];
    for (var i = 0; i < appIDList.length; i++) {
        var appID = appIDList[i].toString();
        var appPath = (0, exports.convertPath)(appPathList[i][0]);
        var modPath = (0, exports.convertPath)(appPathList[i][1]);
        var appName = hexToString(appNameList[i]);
        var subnetList = appSubnetList[i].map(function (subnetID) {
            return subnetID.toString();
        });
        var multiplier = appMultiplier[i].map(function (arr) {
            return arr.map(function (e) { return Number(e); });
        });
        var resourceType = appResourceType[i].map(function (res) {
            return Number(res);
        });
        var resourceCount = appResourceCount[i].map(function (res) {
            return Number(res);
        });
        var appParam = {
            blockNumber: blockNumber,
            nftID: nftID,
            eventType: "update",
            appID: appID,
            appName: appName,
            appPath: appPath,
            modPath: modPath,
            subnetList: subnetList,
            multiplier: multiplier,
            resourceType: resourceType,
            resourceCount: resourceCount,
        };
        appParamList.push(appParam);
    }
    return appParamList;
};
exports.convertCreateAppBatchParam = convertCreateAppBatchParam;
var convertUpdateAppBatchParam = function (blockNumber, param) {
    var PARAMID = {
        nftID: 1,
        appID: 2,
        appName: 3,
        path: 4,
        subnetList: 5,
        multiplier: 6,
        resourceCount: 7,
        resourceType: 8,
    };
    console.log("param: ", param);
    var nftID = param[PARAMID.nftID].toString();
    var appIDList = param[PARAMID.appID];
    var appPathList = param[PARAMID.path];
    var appNameList = param[PARAMID.appName];
    var appSubnetList = param[PARAMID.subnetList];
    var appMultiplier = param[PARAMID.multiplier];
    var appResourceCount = param[PARAMID.resourceCount];
    var appResourceType = param[PARAMID.resourceType];
    var appParamList = [];
    for (var i = 0; i < appIDList.length; i++) {
        var appID = appIDList[i].toString();
        var appPath = (0, exports.convertPath)(appPathList[i][0]);
        var modPath = (0, exports.convertPath)(appPathList[i][1]);
        var appName = hexToString(appNameList[i]);
        console.log("appNameList: ", appNameList, appName);
        var subnetList = appSubnetList[i].map(function (subnetID) {
            return subnetID.toString();
        });
        var multiplier = appMultiplier[i].map(function (arr) {
            return arr.map(function (e) { return Number(e); });
        });
        var resourceType = appResourceType[i].map(function (res) {
            return Number(res);
        });
        var resourceCount = appResourceCount[i].map(function (res) {
            return Number(res);
        });
        var appParam = {
            blockNumber: blockNumber,
            nftID: nftID,
            eventType: "update",
            appID: appID,
            appName: appName,
            appPath: appPath,
            modPath: modPath,
            subnetList: subnetList,
            multiplier: multiplier,
            resourceType: resourceType,
            resourceCount: resourceCount,
        };
        appParamList.push(appParam);
    }
    return appParamList;
};
exports.convertUpdateAppBatchParam = convertUpdateAppBatchParam;
var convertUpdateAppParam = function (blockNumber, param) {
    var PARAMID = {
        nftID: 1,
        appID: 2,
        appName: 3,
        path: 4,
        subnetList: 5,
        multiplier: 6,
        resourceCount: 7,
        resourceType: 8,
    };
    var nftID = param[PARAMID.nftID].toString();
    var appID = param[PARAMID.appID].toString();
    var _a = param[PARAMID.path], appPath = _a[0], modPath = _a[1];
    appPath = (0, exports.convertPath)(appPath);
    modPath = (0, exports.convertPath)(modPath);
    var appName = param[PARAMID.appName];
    appName = hexToString(appName);
    var subnetList = param[PARAMID.subnetList].map(function (t) {
        return t.toString();
    });
    var multiplier = param[PARAMID.multiplier].map(function (arr) { return arr.map(function (e) { return Number(e); }); });
    var resourceCount = param[PARAMID.resourceCount].map(function (e) { return Number(e); });
    var resourceType = param[PARAMID.resourceType].map(function (e) { return Number(e); });
    var convertParams = {
        blockNumber: blockNumber,
        // eventID: NFT_EVENT_ID_MAP.UPDATE_APP,
        eventType: "update",
        nftID: nftID,
        appID: appID,
        appName: appName,
        appPath: appPath,
        modPath: modPath,
        subnetList: subnetList,
        multiplier: multiplier,
        resourceCount: resourceCount,
        resourceType: resourceType,
    };
    return convertParams;
};
exports.convertUpdateAppParam = convertUpdateAppParam;
var getEventABI = function (ContractABI, eventName) {
    var Fragment = ContractABI.find(function (res) { return res.name === eventName && res.type === "event"; });
    var ABI = Fragment.inputs.map(function (res) { return res.internalType; });
    return ABI;
};
exports.getEventABI = getEventABI;
var dateToCron = function (date) {
    var minutes = date.getMinutes();
    var hours = date.getHours();
    var days = date.getDate();
    var months = date.getMonth() + 1;
    var dayOfWeek = date.getDay();
    return "".concat(minutes, " ").concat(hours, " ").concat(days, " ").concat(months, " ").concat(dayOfWeek);
};
exports.dateToCron = dateToCron;
var apiCallWrapper = function (apiCall, format, modifyRet) { return __awaiter(void 0, void 0, void 0, function () {
    var retVal, resp, tempFormat, err_1, error;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, apiCall];
            case 1:
                resp = _a.sent();
                tempFormat = format;
                if (modifyRet) {
                    retVal = modifyRet({ resp: resp, success: true });
                }
                else {
                    retVal = {
                        success: true,
                        data: tempFormat(resp),
                    };
                }
                return [3 /*break*/, 3];
            case 2:
                err_1 = _a.sent();
                error = err_1;
                if (modifyRet) {
                    retVal = modifyRet({ resp: error, success: false });
                }
                else {
                    retVal = {
                        success: false,
                        data: error,
                    };
                }
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/, retVal];
        }
    });
}); };
exports.apiCallWrapper = apiCallWrapper;
var statusCheckCallWrapper = function (apiCall, getStatusCode, format, modifyRet) { return __awaiter(void 0, void 0, void 0, function () {
    var result, resp, tempFormat, err_2, error;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                return [4 /*yield*/, apiCall];
            case 1:
                resp = _a.sent();
                tempFormat = format;
                if (modifyRet) {
                    result = modifyRet({ resp: resp, success: true });
                }
                else {
                    result = {
                        success: true,
                        statusCode: getStatusCode({
                            success: true,
                            resp: resp,
                        }),
                        data: tempFormat(resp),
                    };
                }
                return [3 /*break*/, 3];
            case 2:
                err_2 = _a.sent();
                error = err_2;
                if (modifyRet) {
                    result = modifyRet({ resp: error, success: false });
                }
                else {
                    result = {
                        success: false,
                        data: error,
                        statusCode: getStatusCode({
                            success: false,
                            resp: error,
                        }),
                    };
                }
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/, result];
        }
    });
}); };
exports.statusCheckCallWrapper = statusCheckCallWrapper;
var isValidCPUInstance = function (resourceType) {
    var cpuNumbers = 0;
    var index;
    for (var i = 0; i < resourceType.length; i++) {
        var resourceTypeElement = resourceType[i];
        var isCPUPresent = constant_1.RESOURCE_TYPE_CATEGORIES.cpuInstance.includes(resourceTypeElement);
        if (isCPUPresent) {
            cpuNumbers++;
            index = i;
        }
        if (cpuNumbers > 1)
            break;
    }
    if (cpuNumbers === 1)
        return { status: true, index: index };
    return {
        status: false,
        message: "Error : you have to select exact one instance for all resources",
    };
};
exports.isValidCPUInstance = isValidCPUInstance;
var stringifyTryCatch = function (data) {
    try {
        return JSON.stringify(data, function (key, value) {
            return typeof value === "bigint" ? value.toString() : value;
        });
    }
    catch (err) {
        return "(failed to stringify)";
    }
};
exports.stringifyTryCatch = stringifyTryCatch;
